﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using System.Data;
using MVC_LoadOnDemand_IgHierachicalGrid.Models;

namespace MVC_LoadOnDemand_IgHierachicalGrid.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/






        public ActionResult Index()
        {

            GridModel grid = new GridModel();
            grid.LoadOnDemand = true;
            grid.DataSourceUrl = this.Url.Action("GetData");
            grid.ID = "grid1";
            grid.Width = "500px";

            grid.Height = "500px";
            grid.DataMember = "Items";
            grid.AutoGenerateColumns = false;
            grid.Columns.Add(new GridColumn("id", "ID", "number", "100xp"));
            grid.Columns.Add(new GridColumn("Name", "Name", "string", "100xp"));
            grid.Columns.Add(new GridColumn("Data", "Data", "string", "100xp"));
            grid.AutoGenerateLayouts = false;


            GridModel childGrid = new GridModel();
            grid.ColumnLayouts.Add(childGrid);

            childGrid.DataSourceUrl = this.Url.Action("GetChildData");
            childGrid.PrimaryKey = "ID";
            childGrid.ForeignKey = "ID";
            childGrid.AutoGenerateColumns = false;
            childGrid.Columns.Add(new GridColumn("id", "ID", "number", "100xp"));
            childGrid.Columns.Add(new GridColumn("Name", "Name", "string", "100xp"));


            childGrid.AutoGenerateLayouts = false;
            grid.DataBind();


            return View(grid);

        }
        [GridDataSourceAction]
        [ActionName("GetData")]
        public ActionResult GetData()
        {

            List<Items> items = new List<Items>() { new Items() { ID = 1, Name = "Name 1", Data = "Data", subItems = new List<SubItems>() { new SubItems() { ID = 1, Name = "Sub Item 1", Data = "Data" } } } };
            return View(items.AsQueryable());
        }

        [GridDataSourceAction]
        [ActionName("GetChildData")]
        public ActionResult GetChildData()
        {

            List<SubItems> items = new List<SubItems>() { new SubItems() { ID = 1, Name = "Sub Item 1", Data = "Data" } };
            return View(items.AsQueryable());
        }

    }
}
